'use strict';Object.defineProperty(exports,'__esModule',{value:true});//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//

var script = {
  props: ["title","subtitle","columns","list","action","pages","labelBack","labelNext"],
  data: function data() {
    return {
      page: 1
    }
  },
  methods: {
    /**
     * Load List Items page by page
     */
    loadListItems: function loadListItems() {
      this.$store.dispatch(this.action, { page: this.page });
    },
    /**
     * Load next page
     */
    nextPage: function nextPage() {
      if (this.hasNextPage()) {
        this.page++;
      }
      this.loadListItems();
    },
    /**
     * Check if there is a next page
     * @returns {boolean}
     */
    hasNextPage: function hasNextPage() {
      if (this.page <= this.pages - 1) {
        return true;
      } else {
        return false;
      }
    },
    /**
     * Check if there is a previous page
     * @returns {boolean}
     */
    hasPrevPage: function hasPrevPage() {
      if (this.page > 1) {
        return true;
      } else {
        return false;
      }
    },
    /**
     * Load previous page
     */
    prevPage: function prevPage() {
      if (this.hasPrevPage()) {
        this.page--;
      }
      this.loadListItems();
    },
  }
};function normalizeComponent(template, style, script, scopeId, isFunctionalTemplate, moduleIdentifier /* server only */, shadowMode, createInjector, createInjectorSSR, createInjectorShadow) {
    if (typeof shadowMode !== 'boolean') {
        createInjectorSSR = createInjector;
        createInjector = shadowMode;
        shadowMode = false;
    }
    // Vue.extend constructor export interop.
    var options = typeof script === 'function' ? script.options : script;
    // render functions
    if (template && template.render) {
        options.render = template.render;
        options.staticRenderFns = template.staticRenderFns;
        options._compiled = true;
        // functional template
        if (isFunctionalTemplate) {
            options.functional = true;
        }
    }
    // scopedId
    if (scopeId) {
        options._scopeId = scopeId;
    }
    var hook;
    if (moduleIdentifier) {
        // server build
        hook = function (context) {
            // 2.3 injection
            context =
                context || // cached call
                    (this.$vnode && this.$vnode.ssrContext) || // stateful
                    (this.parent && this.parent.$vnode && this.parent.$vnode.ssrContext); // functional
            // 2.2 with runInNewContext: true
            if (!context && typeof __VUE_SSR_CONTEXT__ !== 'undefined') {
                context = __VUE_SSR_CONTEXT__;
            }
            // inject component styles
            if (style) {
                style.call(this, createInjectorSSR(context));
            }
            // register component module identifier for async chunk inference
            if (context && context._registeredComponents) {
                context._registeredComponents.add(moduleIdentifier);
            }
        };
        // used by ssr in case component is cached and beforeCreate
        // never gets called
        options._ssrRegister = hook;
    }
    else if (style) {
        hook = shadowMode
            ? function (context) {
                style.call(this, createInjectorShadow(context, this.$root.$options.shadowRoot));
            }
            : function (context) {
                style.call(this, createInjector(context));
            };
    }
    if (hook) {
        if (options.functional) {
            // register for functional component in vue file
            var originalRender = options.render;
            options.render = function renderWithStyleInjection(h, context) {
                hook.call(context);
                return originalRender(h, context);
            };
        }
        else {
            // inject component registration as beforeCreate hook
            var existing = options.beforeCreate;
            options.beforeCreate = existing ? [].concat(existing, hook) : [hook];
        }
    }
    return script;
}/* script */
var __vue_script__ = script;

/* template */
var __vue_render__ = function () {var _vm=this;var _h=_vm.$createElement;var _c=_vm._self._c||_h;return _c('b-card',{attrs:{"no-body":""}},[_c('b-card-header',[_c('b-row',[_c('b-col',{attrs:{"md":"8"}},[_c('h3',{staticClass:"card-label"},[_vm._v("\n          "+_vm._s(_vm.title)+"\n          "),_c('small',[_vm._v(_vm._s(_vm.subtitle))])])]),_vm._v(" "),_c('b-col',{attrs:{"md":"2"}},[(_vm.hasPrevPage())?_c('a',{staticClass:"text-white",on:{"click":function($event){return _vm.prevPage()}}},[_c('i',{staticClass:"fas fa-chevron-left mr-2"}),_vm._v("\n          "+_vm._s(_vm.labelBack)+"\n        ")]):_vm._e()]),_vm._v(" "),_c('b-col',{staticClass:"text-right",attrs:{"md":"2"}},[(_vm.hasNextPage())?_c('a',{staticClass:"text-white",on:{"click":function($event){return _vm.nextPage()}}},[_vm._v("\n          "+_vm._s(_vm.labelNext)+"\n          "),_c('i',{staticClass:"fas fa-chevron-right ml-2"})]):_vm._e()])],1)],1),_vm._v(" "),_c('b-card-body',{staticClass:"p-0"},[(_vm.list.length > 0)?_c('b-list-group',[_c('b-list-group-item',[_c('b-row',_vm._l((_vm.columns),function(column,i){return _c('b-col',{key:i,attrs:{"md":column.md}},[_vm._v("\n            "+_vm._s(column.label)+"\n          ")])}),1)],1),_vm._v(" "),_vm._l((_vm.list),function(item){return _c('b-list-group-item',{key:item.id},[_c('b-row',_vm._l((_vm.columns),function(column,i){return _c('b-col',{key:i,attrs:{"md":column.md}},[_vm._v("\n            "+_vm._s(item[column.prop])+"\n          ")])}),1)],1)})],2):_vm._e(),_vm._v(" "),(_vm.list.length == 0)?_c('div',{staticClass:"progress",staticStyle:{"position":"relative"}},[_c('div',{staticClass:"progress-bar bg-info progress-bar-striped indeterminate"})]):_vm._e()],1)],1)};
var __vue_staticRenderFns__ = [];

  /* style */
  var __vue_inject_styles__ = undefined;
  /* scoped */
  var __vue_scope_id__ = undefined;
  /* module identifier */
  var __vue_module_identifier__ = "data-v-4db76a29";
  /* functional template */
  var __vue_is_functional_template__ = false;
  /* style inject */
  
  /* style inject SSR */
  
  /* style inject shadow dom */
  

  
  var __vue_component__ = /*#__PURE__*/normalizeComponent(
    { render: __vue_render__, staticRenderFns: __vue_staticRenderFns__ },
    __vue_inject_styles__,
    __vue_script__,
    __vue_scope_id__,
    __vue_is_functional_template__,
    __vue_module_identifier__,
    false,
    undefined,
    undefined,
    undefined
  );// Import vue component

// install function executed by Vue.use()
function install(Vue) {
  if (install.installed) { return; }
  install.installed = true;
  Vue.component('VuePagedList', __vue_component__);
}

// Create module definition for Vue.use()
var plugin = {
  install: install,
};

// To auto-install when vue is found
var GlobalVue = null;
if (typeof window !== 'undefined') {
  GlobalVue = window.Vue;
} else if (typeof global !== 'undefined') {
  GlobalVue = global.Vue;
}
if (GlobalVue) {
  GlobalVue.use(plugin);
}

// Inject install function into component - allows component
// to be registered via Vue.use() as well as Vue.component()
__vue_component__.install = install;

// It's possible to expose named exports when writing components that can
// also be used as directives, etc. - eg. import { RollupDemoDirective } from 'rollup-demo';
// export const RollupDemoDirective = component;
exports.default=__vue_component__;//# sourceMappingURL=vue-bootstrap-pagedlist.ssr.js.map
